unit IntelAble;

interface

uses
  SysUtils;

type
  WrapperHandle = Pointer;

function NewWrapper : WrapperHandle; cdecl;
procedure DisconnectFromIntel(handle : WrapperHandle); cdecl;
function ConnectToIntelADP(handle : WrapperHandle;
  p1, p2, p3, p4 : Cardinal; baKnoID : PAnsiChar) : Integer; cdecl;
function Upgrade(handle : WrapperHandle;
  p1, p2, p3, p4 : Cardinal) : Integer; cdecl;
function GetIntelADPStatus(handle : WrapperHandle) : Integer; cdecl;
function BeginIntelEvent(handle : WrapperHandle) : Integer; cdecl;
function EndIntelEvent(handle : WrapperHandle) : Integer; cdecl;
function GetErrorMessage(messageNum : Integer) : String;

implementation

const
  DLLName = 'IntelAble.dll';

function NewWrapper; external DLLName;
procedure DisconnectFromIntel; external DLLName;
function ConnectToIntelADP; external DLLName;
function Upgrade; external DLLName;
function GetIntelADPStatus; external DLLName;
function BeginIntelEvent; external DLLName;
function EndIntelEvent; external DLLName;

function GetErrorMessage(messageNum : Integer) : String;
var
  errMessage : String;
begin
  case messageNum of
    -10: errMessage := 'The baKno GUID is Invalid';
    -3 : errMessage := 'Could not Locate File: baKno.dll';
    -2 : errMessage := 'Invalid File : bakNo.dll';
    1 : errMessage := 'Client Agent not Initialized';
    2 : errMessage := 'No Client Available';
    3 : errMessage := 'The Version of the Client Agent is Incompatible';
    4 : errMessage := 'The Data is too Large';
    6 : errMessage := 'The Application is not Authotized';
    7 : errMessage := 'The Application is no longer Authotized';
    8 : errMessage := 'BeginEvent Must Come First';
    9 : errMessage := 'The Communication has Reached a Timeout';
  else
    errMessage := 'Unknown Error';
  end;
  Result := errMessage;
end;

end.
